/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.partner.model;

import domen.PoslovniPartner;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class PartnerTableModel extends AbstractTableModel {
    
    private List<PoslovniPartner> lp;
    private String[] kolone = new String[]{"PartnerID", "Naziv", "PIB", "Matični broj", "Datum", "Žiro račun", "Ulica", "Broj", "Mesto"};

    public PartnerTableModel(List<PoslovniPartner> lp) {
        this.lp = lp;
    }
    
    @Override
    public int getRowCount() {
        if (lp != null) {
            return lp.size();
        }
        return 0;
    }

    @Override
    public int getColumnCount() {
        return kolone.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        PoslovniPartner pp = lp.get(rowIndex);
        switch (columnIndex) {
            case 0 : return pp.getPartnerID();
            case 1 : return pp.getNaziv();
            case 2 : return pp.getPib();
            case 3 : return pp.getMaticniBroj();
            case 4 : return pp.getDatumOsnivanja();
            case 5 : return pp.getZiroRacun();
            case 6 : return pp.getUlica();
            case 7 : return pp.getBroj();
            case 8 : return pp.getMesto();
            default : return "n/a";
        }
    }
    
    @Override
    public String getColumnName(int column) {
        return kolone[column];
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 1) {
            return true;
        }
        return false;
    }
    
    public PoslovniPartner vratiPartnera(int red) {
        return lp.get(red);
    }
    
}
