/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package poslovnalogika;

import db.DbKomunikacija;
import domen.Mesto;
import domen.PoslovniPartner;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author student1
 */
public class Kontroler {
    private KolekcijaMesta km;
    private KolekcijaPoslovnihPartnera kp;
    private DbKomunikacija db;
    private static Kontroler instance;
    private Map<String, Object> map;
    
    private Kontroler() {
        km = new KolekcijaMesta();
        kp = new KolekcijaPoslovnihPartnera();
        db = new DbKomunikacija();
        map = new HashMap<>();
    }
    
    public static Kontroler getInstance() {
        if (instance == null) {
            instance = new Kontroler();
        }
        return instance;
    }
    
    public void dodajPartnera(PoslovniPartner p) throws Exception {
        //kp.dodajPartnera(p);
        db.ucitajDriver();
        db.otvoriKonekciju();
        db.sacuvajPartnera(p);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }
    
    public List<PoslovniPartner> vratiPartnere() {
        return kp.vratiPartnere();
    }
    
    public void dodajMesto(Mesto m) {
        km.dodajMesto(m);
    }
    
    public List<Mesto> vratiMesta() throws Exception {
        //return km.vratiMesta();
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Mesto> lm = db.vratiMesta();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lm;
    }
    
    public void put(String key, Object value) {
        map.put(key, value);
    }
    
    public Object get(String key) {
        return map.get(key);
    }
    
    public void remove(String key) {
        map.remove(key);
    }
    
    public PoslovniPartner izmeniPartnera(PoslovniPartner p) {
        return kp.izmeniPartnera(p);
    }
    
    public void sauvajPartnere(List<PoslovniPartner> lp) throws Exception {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            for (PoslovniPartner pp : lp) {
                db.sacuvajPartnera(pp);
                System.out.println("Sacuvao sam partnera: " + pp.getPartnerID());
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
        
    }
    
}
