/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.racun.model;

import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class RacunTableModel extends AbstractTableModel {

    private Racun racun;

    public RacunTableModel(Racun racun) {
        this.racun = racun;
    }

    @Override
    public int getRowCount() {
        if (racun != null && racun.getStavkaList() != null) {
            return racun.getStavkaList().size();
        }
        return 0;
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getStavkaList().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return stavka.getProizvod();
            case 1:
                return stavka.getKolicina();
            case 2:
                return stavka.getIznos();
            default:
                return "n/a";
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 2) {
            return false;
        }
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna stavka = racun.getStavkaList().get(rowIndex);
        switch (columnIndex) {
            case 0:
                stavka.setProizvod((Proizvod) aValue);
                stavka.setIznos(stavka.getProizvod().getCena() * stavka.getKolicina());
                fireTableCellUpdated(rowIndex, columnIndex + 2);
                break;
            case 1:
                stavka.setKolicina(Integer.parseInt((String) aValue));
                stavka.setIznos(stavka.getProizvod().getCena() * stavka.getKolicina());
                fireTableCellUpdated(rowIndex, columnIndex + 1);
                break;
            case 2:
                // Ovo ne sme da se promeni
                break;
        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "Proizvod";
            case 1:
                return "Kolicina";
            case 2:
                return "Iznos";
            default:
                return "n/a";
        }
    }
    
    public void dodajStavku() {
        racun.dodajStavku();
        fireTableDataChanged();
    }
    
    public void obrisiStavku(int red) {
        racun.getStavkaList().remove(red);
        fireTableDataChanged();
    }
    
    public Racun vratiRacun() {
        return racun;
    }
}
