/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domen.Mesto;
import domen.PravnoLice;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Util;

/**
 *
 * @author student1
 */
public class DBKonekcija {

    public void sacuvajPravnoLice(PravnoLice pl) {
        try {
            //ucitaj driver
            Class.forName("com.mysql.jdbc.Driver");
            System.out.println("Driver je ucitan");
            String url = Util.url;
            String password = Util.password;
            String username = Util.username;
            Connection connection = DriverManager.getConnection(url, username, password);
            System.out.println("Konekcija je uspostavljena");

            String upit = "INSERT INTO pravnolice VALUES (?,?,?,?,?,?,?,?)";
            PreparedStatement ps = connection.prepareStatement(upit);
            ps.setString(1, pl.getMaticniBroj());
            ps.setString(2, pl.getNaziv());
            ps.setString(3, pl.getPib());
            ps.setDate(4, new Date(pl.getDatumOsnivanja().getTime()));
            ps.setLong(5, pl.getMestoSediste().getPtt());
            ps.setString(6, pl.getOpstinaSediste());
            ps.setString(7, pl.getUlicaSediste());
            ps.setString(8, pl.getBrojSediste());

            ps.executeUpdate();
            System.out.println("Upit je izvrsen");
            ps.close();
            connection.close();

        } catch (ClassNotFoundException ex) {
            System.out.println("Driver ne postoji: " + ex.getMessage());
        } catch (SQLException sqlEx) {
            System.out.println("Konekcija nije uspostavljena " + sqlEx.getMessage());
        }

    }

    public List<Mesto> vratiListuMesta() {
        List<Mesto> listaMesta = new ArrayList<>();

        try {
            Class.forName("com.mysql.jdbc.Driver");
            System.out.println("Driver je ucitan");
            String url = Util.url;
            String password = Util.password;
            String username = Util.username;
            Connection connection = DriverManager.getConnection(url, username, password);
            System.out.println("Konekcija je uspostavljena");

            String upit = "SELECT * FROM mesto";
            Statement s = connection.createStatement();
            ResultSet rs = s.executeQuery(upit);

            while (rs.next()) {
                long ptt = rs.getLong("ptt");
                String naziv = rs.getString("naziv");
                Mesto m = new Mesto(ptt, naziv);
                listaMesta.add(m);
            }
            s.close();
            connection.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

        return listaMesta;
    }

    public List<PravnoLice> vratiListuPravnihLica() {
        List<PravnoLice> listaPL = new ArrayList<>();

        try {
            Class.forName("com.mysql.jdbc.Driver");
            System.out.println("Driver je ucitan");
            String url = Util.url;
            String password = Util.password;
            String username = Util.username;
            Connection connection = DriverManager.getConnection(url, username, password);
            System.out.println("Konekcija je uspostavljena");

            String upit = "SELECT * FROM pravnolice";
            Statement s = connection.createStatement();
            ResultSet rs = s.executeQuery(upit);

            while (rs.next()) {

                String mb = rs.getString("maticnibroj");
                String naziv = rs.getString("naziv");
                String pib = rs.getString("pib");
                java.util.Date datum = new java.util.Date(rs.getDate("datumOsnivanja").getTime());
                long mesto = rs.getLong("mestoSediste");
                String opstina = rs.getString("opstinaSediste");
                String ulicaSediste = rs.getString("ulicaSediste");
                String brojSediste = rs.getString("brojSediste");

                PravnoLice pl = new PravnoLice();
                pl.setMaticniBroj(mb);
                pl.setNaziv(naziv);
                pl.setPib(pib);
                pl.setDatumOsnivanja(datum);

                Mesto m = new Mesto();
                m.setPtt(mesto);  // dopuniti

                pl.setMestoSediste(m);
                pl.setOpstinaSediste(opstina);
                pl.setUlicaSediste(ulicaSediste);
                pl.setBrojSediste(brojSediste);

                listaPL.add(pl);

                s.close();
                connection.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return listaPL;

    }

}
